;******************************************;
;				<<< OEFFNG3D.LSP >>>							 ;
;******************************************;
;Autor: K.Habenicht
;Datum der Erstellung: 16.8.1992
;Datum der letzten Vernderung: 7.4.1993
;Funktion: Brechen einer ffnung in eine 
;          Mauer
;*************** Programm *****************;
;Fehlerroutine
(defun *error* (msg)
(princ msg)
(setvar "CMDECHO" cmd)
(setvar "BLIPMODE" blip)
(setvar "OSMODE" osm)
(princ)
)
(defun C:OEFFNG3D ( / refpkt winkel abst pkt1 		
											pkt2 pkt3 pkt4 pkt1z pktz2 pkt3z pkt4z 		
											pkt1h pkt2h pkt3h pkt4h breite elem 			
											raumh hoehe erheb pkt1o pkt2o pkt3o pkt4o)
;Sichern der Systemvariablen
(setq blip (getvar "BLIPMODE"))
(setq osm (getvar "OSMODE"))
(setvar "BLIPMODE" 0)
;Einlesen der Variablen
(setvar "OSMODE" 1)
(setq refpkt (getpoint "Bezugspunkt whlen (OFANG = Endp): "))
(setvar "OSMODE" 512)
(setq winkel (getangle refpkt "\nRichtung festlegen (OFANG = Nc): "))
(setq abst (getdist refpkt "\nAbstand vom Bezugspunkt: "))
(setq pkt1 (polar refpkt winkel abst))
;Ermitteln der Objekthhe der gewhlten Wand
(setq elem (ssname (ssget pkt1) 0))
(setq raumh (cdr (assoc 39 (entget elem))))
(setq breite (getdist pkt1 "\nBreite der ffnung: "))
(setq hoehe (getdist pkt1 "\nHhe der ffnung: "))
(setq erheb (getdist pkt1 "\nErhebung der ffnung: "))
;Ausrechnen aller Punktkoordinaten
(setq 
  pkt1z (list (car pkt1) (cadr pkt1) erheb)
  pkt2 (polar pkt1 winkel breite)
  pkt2z (list (car pkt2) (cadr pkt2) erheb)
  pkt1h (list (car pkt1) (cadr pkt1) (+ erheb hoehe))
  pkt1o (list (car pkt1) (cadr pkt1) raumh)
  pkt2h (list (car pkt2) (cadr pkt2) (+ erheb hoehe))
  pkt2o (list (car pkt2) (cadr pkt2) raumh)
) ;Ende setq
(setvar "OSMODE" 128)
(setq pkt3 (getpoint pkt1 "\nParallele Linie whlen: "))
(setq 
  pkt3z (list (car pkt3) (cadr pkt3) erheb)
  pkt3h (list (car pkt3) (cadr pkt3) (+ erheb hoehe))
  pkt3o (list (car pkt3) (cadr pkt3) raumh)
) ;Ende setq
(setvar "OSMODE" 0)
(setq cmd (getvar "CMDECHO"))
(setvar "CMDECHO" 0)
(setq 
  pkt4 (polar pkt3 winkel breite)
  pkt4z (list (car pkt4) (cadr pkt4) erheb)
  pkt4h (list (car pkt4) (cadr pkt4) (+ erheb hoehe))
  pkt4o (list (car pkt4) (cadr pkt4) raumh)
) ;Ende setq
;Zeichnen der 3D-Flchen
(command 
  "BRUCH" pkt1 pkt2
  "BRUCH" pkt3 pkt4
  "3DFLCHE" pkt1z pkt3z pkt4z pkt2z pkt2h 
             pkt4h pkt3h pkt1h pkt1z pkt3z ""
  "3DFLCHE" pkt1 "u" pkt2 "u" pkt2z u" 
             pkt1z ""
  "3DFLCHE" pkt3 "u" pkt4 "u" pkt4z u" 
             pkt3z ""
  "3DFLCHE" "u" pkt1h "u" pkt2h pkt2o 
             pkt1o ""
  "3DFLCHE" "u" pkt3h "u" pkt4h pkt4o 
             pkt3o ""
) ;Ende command
;Rckstellen der Systemvariablen
(setvar "OSMODE" osm)
(setvar "BLIPMODE" blip)
(setvar "CMDECHO" cmd)
(princ)
)
