;******************************************;
;				<<< SCHRLIN.LSP >>>					       ;
;******************************************;
;Autor: K. Habenicht
;Datum der Erstellung: 6.4.1992
;Funktion: Erzeugen einer dreidimensionalen 
;          Schraublinie
;*************** Programm *****************;
;Fehlerroutine
(defun *error* (msg)
(princ msg)
(setvar "CMDECHO" cmd)
(setvar "BLIPMODE" blip)
(princ)
)
;Hauptprogramm
(defun C:SCHRLIN (/ zp rad gangh anzahl lauf index x1 y1 z1 p1)
;Systemvariablen einstellen
(setq cmd (getvar "CMDECHO"))
(setvar "CMDECHO" 0)
(setq blip (getvar "BLIPMODE"))
(setvar "BLIPMODE" 0)
;Einlesen der Variablen
(setq
 zp (getpoint "Zentrum der Schraublinie:")
 rad (getdist zp "Radius der Schraublinie: ")
 gangh (getreal "Ganghhe: ")
 anzahl (getint "Anzahl der Gnge: ")
 lauf 0
)
;Aufruf des Befehls 3DPOLY
(command "3DPOLY")
;Schleife fr die bergabe der Scheitelpunkte
;uere Schleife fr die Anzahl der Gnge
(while (< lauf anzahl) 
	(setq index 0)
	;Innere Schleife fr einen Gang
	;Kreis wurde in 36 Teilstcke geteilt
	(while (< index 36)
	;Berechnen der Koordinaten
	(setq x1 (+ (car zp) (* rad (cos (* (/ pi 18) index)))))
	(setq y1 (+ (cadr zp)	(* rad (sin (* (/ pi 18) index)))))
	(setq z1 (+ (caddr zp) (* gangh lauf) (* gangh (/ index 36.0))))
	;Punkt zusammenfgen
	(setq p1 (list x1 y1 z1))
	;Punkt an der Befehl 3DPOLY bergeben
	(command p1)
	;Schleifenindizes erhhen
	(setq index (1+ index))
	) ;Ende innere Schleife
(setq lauf (1+ lauf))
) ;Ende uere Schleife
;Befehl 3DPOLY abschlieen
(command "");
Befehl PEDIT zur Glttung aufrufen
(command "PEDIT" "l" "k" "")
;Systemvariablen zurckstellen
(setvar "CMDECHO" cmd)
(setvar "BLIPMODE" blip)
(princ)
)  
